package com.ashokit.problems;

import java.util.Scanner;

public class HalfOrDouble {

    // Method to get half of the number using bitwise right shift
    public static int getHalf(int number) {
        return number >> 1; // Right shift by 1 bit
    }

    // Method to get double of the number using bitwise left shift
    public static int getDouble(int number) {
        return number << 1; // Left shift by 1 bit
    }
    public static int getSquare(int number) {
        int square = 0;
        int absNumber = number < 0 ? ~number + 1 : number; // Handle negative numbers (absolute value)

        for (int i = 0; i < absNumber; i++) {
            square += number; // Add 'number' to itself repeatedly
        }

        return square;
    }

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        // Input a number
        System.out.print("Enter a number: ");
        int number = scanner.nextInt();

        // Display the half and double of the number
        System.out.println("Half of the number: " + getHalf(number));
        System.out.println("Double of the number: " + getDouble(number));
        System.out.println("Square of the number: " + getSquare(number));

    }
}

