package com.ashokit.sortings;

import java.util.Arrays;

public class HeapSort {
	
	public static void main(String[] args) {
		int a[]= {10,11,1,15,3,2};
		int n=a.length;//6
		for (int i = ((n/2)-1); i >=0; i--) {//i=0
			heapify(a,i,n);//heapify(a,0,6)
		}
		
		//swap 0th index with length-1 index
		System.out.println("Array before Sorting "+Arrays.toString(a));
		for (int i = a.length-1; i >=0; i--) {//4
			int temp=a[0];
			a[0]=a[i];
			a[i]=temp;
			heapify(a,0,i);
			System.out.println("for each iteration "+Arrays.toString(a));
		}
		System.out.println("Array after Sorting "+Arrays.toString(a));
		
	}
	
	public static void heapify(int a[],int i,int len) {//i=3,len=5
		
		int parentPos=i;//parentPos=3
		int lcp=2*i+1;//lcp=7
		int rcp=2*i+2;//rcp=8
		
		if(lcp<len && a[parentPos]<a[lcp]) {//7<5 && a[1]<a[3]==>1<10
			parentPos=lcp;//parentPos=3
		}
		if(rcp<len && a[parentPos]<a[rcp]) {//8<5 && a[3]<a[4]=11<2
			parentPos=rcp;
		}
		if(parentPos!=i) {//3!=3
			//swap parent, pos with i
			int temp = a[i];
            a[i] = a[parentPos];
            a[parentPos] = temp;
            heapify(a,parentPos,len);//a,3,5
		}
		
	}
	
	

}
