package com.ashokit.sortings;

import java.util.Arrays;

public class QuickSortHoarersPartition {
	
	public static void main(String[] args) {
		int a[]= {10,6,9,15,18,4,3,21};
		System.out.println("Before Sort"+Arrays.toString(a));
		quickSort(a,0,a.length-1);
		System.out.println("after Sort"+Arrays.toString(a));
		
	}
	
	public static void quickSort(int a[],int l,int h) {//4, 6

		//int m=l+h/2;
		if(l<h) {//4<6
			int pi=partition(a,l,h);//partition(a,4,6)
			quickSort(a,0,pi-1);//quickSort(a,0,2)
			quickSort(a, pi+1, h);//quickSort(a,4,7)
		}
	}
	
	public static int partition(int a[],int l,int h) {//l=4;h=6
		int PIVOT=a[l];
		int i=l;//i=0;
		int j=h;//7
		// {10,6,9,3,18,4,15,21};
		while(i<j) {//0<7
			i++;//4
			while(a[i]<PIVOT) {//18<10 ==i=3
				i++;//5
			}
			while(a[j]>PIVOT) {//3>10
				j--;//6
			}
			//i =3 where element is great than PIVOT
			//j=6 where element is lesser than PIVOT
			if(i<j) {
				swap(a,i,j);
			}
		}
		swap(a,l,j);
		return j;
		//Increment I value untill you get a element greater than PIVOT
		//decrement J value untill you get a element lesser than PIVOT
	}
	
	static private void swap(int[] a, int i, int j) {
		if (i >= 0 && j >= 0 && i < a.length && j < a.length) {
			int tmp = a[i];
			a[i] = a[j];
			a[j] = tmp;
		}
	}

}
