package com.ashokit.graph;

import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;
import java.util.Set;
import java.util.Stack;

import com.ashokit.tree.Employee;

public class GraphRepresentation {
	
	LinkedList[] adjcencyList=null;
	Employee[] e= null;
	GraphRepresentation(int noOfVertexes){
		adjcencyList= new LinkedList[noOfVertexes];
		System.out.println(adjcencyList[0]);
		for (int i = 0; i < noOfVertexes; i++) {
			adjcencyList[i]= new LinkedList<>();
		}
		e=new Employee[5];
		System.out.println("Hi");
		//sysout(e[0])
	}
	
	//LinkedList adjcencyList[]= new Linkedlist[5];
	//sysout(adjcencyList[0]);
	public void add(int source,int destination) {
		LinkedList l= adjcencyList[source];
		l.add(destination);
		
	}
	
	public void BFS(int vertex) {//4
		
		Queue<Integer> q= new LinkedList<>();
		Set<Integer> s= new HashSet<>();
		
		q.add(vertex);//q=4
		s.add(vertex);//s=4
		
		while(!q.isEmpty()) {//q=[],s=[4,1,3]
			
			int visitingVertex =q.poll();//visitedVertex=2, q=[],s=[4,1,3,0,2]
			System.out.print(visitingVertex+" ");//4 1 3 0 2
			LinkedList l1= adjcencyList[visitingVertex];//l1=[1,2]
			for (int i = 0; i < l1.size(); i++) {
				int element=(int) l1.get(i);//0 3
				if(!s.contains(element)) {
					q.add(element);
					s.add(element);
				}
			}
		}
		
		
	}
	
	public void DFS(int vertex) {//4
		
		Stack<Integer> stack= new Stack<>();
		Set<Integer> s= new HashSet<>();
		
		stack.add(vertex);//q=4
		s.add(vertex);//s=4
		
		while(!stack.isEmpty()) {//stack=[4],s=[4]
			
			int visitingVertex =stack.pop();//visitedVertex=2, q=[],s=[4,1,3,0,2]
			System.out.print(visitingVertex+" ");//4 1 3 0 2
			LinkedList l1= adjcencyList[visitingVertex];//l1=[1,2]
			for (int i = 0; i < l1.size(); i++) {
				int element=(int) l1.get(i);//0 3
				if(!s.contains(element)) {
					stack.add(element);
					s.add(element);
				}
			}
		}
		
		
	}
	
	public static void main(String[] args) {
		GraphRepresentation g= new GraphRepresentation(5);
		g.add(0,1);
		g.add(0,2);
		g.add(1, 0);
		g.add(1, 3);
		g.add(1, 4);
		g.add(2, 0);
		g.add(2, 3);
		//g.add(3, 0);
		g.add(3, 1);
		g.add(3, 2);
		g.add(3, 4);
		g.add(4, 3);
		g.add(4,1);
		g.BFS(4);
		System.out.println("DFS op");
		g.DFS(4);
		
	}

}
