package com.ashokit.problems;



  
   class ListNode {
      int val;
      ListNode next;
      ListNode() {}
      ListNode(int val) { this.val = val; }
      ListNode(int val, ListNode next) { this.val = val; this.next = next; }
  }
 
class Solution {
    public ListNode removeNthFromEnd(ListNode head, int n) {
        ListNode dummy = new ListNode(0, head);//0->1->2->3->4->5
        ListNode first = dummy;//0->1->2->3->4->5
        ListNode second = dummy;//0->1->2->3->4->5

        // Move the first pointer n+1 steps ahead
        for (int i = 0; i <= n; i++) {//i=3<=2
            first = first.next;//3
        }

        // Move both pointers until the first pointer reaches the end
        while (first != null) {//null
            first = first.next;//null
            second = second.next;//3
        }

        // Remove the nth node from the end
        second.next = second.next.next;

        // Return the updated list
        return dummy.next;
        
        /*if(head==null){
            return null;
        }else{
            ListNode temp=head;
            int count=0;
            while(temp!=null){
                count++;//5
                temp=temp.next;
            }
            System.out.println("count "+count);
            int dNumber=count-n+1;//2-2+1=1
            System.out.println("dNumber "+dNumber);
            ListNode previous=null;
            if(dNumber==n && count==n){                
                    return null;
            }else{
                int newCount=0;
                 ListNode temp1=head;
                 if(dNumber+1==n){
                    head=head.next;
                    return head;
                 }
                 
                while(temp1.next!=null){//2
                    System.out.println("data "+temp1.val);
                    newCount=newCount+1;//1
                    System.out.println("newCount "+newCount);

                    if(dNumber==n){//2==2
                        if(previous!=null){
                            System.out.println("previous "+previous.val);
                        previous.next=temp1.next;
                        temp1.next=null;
                        return head;
                        }
                    }else{
                        previous=temp1;//1
                        temp1=temp1.next; //2                       
                    }
                }
                if(dNumber==newCount+1){
                    if(previous!=null){
                        previous.next=null;
                        return head;
                    }
                }

            }
        }
        return head;*/
    }
}
