package com.ashokit.tree;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.Map;
import java.util.Queue;

public class VerticalOrderTraversal {

	Node root=null;
	public static void main(String[] args) {
		VerticalOrderTraversal v= new VerticalOrderTraversal();
		v.root= new Node(10);
		v.root.left= new Node(9);
		v.root.right= new Node(8);
		v.root.left.left= new Node(6);
		v.root.left.right= new Node(6);
		v.root.right.left= new Node(5);
		v.root.right.right= new Node(3);
		v.verticalOrderTraversal(v.root);
		
	}
	
	public void verticalOrderTraversal(Node root) {
		if(root==null) {
			return;
		}
		Pair p= new Pair(root,0);
		Queue<Pair> queue= new LinkedList<>();
		queue.add(p);//[root(10),0]
		Map<Integer, ArrayList<Object>> levelMap=new HashMap<>();
		while (!queue.isEmpty()) {
			for (int i = 0; i < queue.size(); i++) {
				Pair p1=queue.poll();//root(10),0
				Node n1= p1.node;//10
				int verticleLineNumber=p1.verticleLineNumber;//0
				if(!levelMap.containsKey(verticleLineNumber)) {
					levelMap.put(verticleLineNumber, new ArrayList<>());//0,AL
				}
				levelMap.get(verticleLineNumber).add(n1.data);//0->10
				if(n1.left!=null) {
					queue.add(new Pair(n1.left, verticleLineNumber-1));
				}
				if(n1.right!=null) {
					queue.add(new Pair(n1.right, verticleLineNumber+1));
				}

			}

		}
		System.out.println(levelMap);


	}
	class Pair{
		Node node;
		int verticleLineNumber;
		Pair(Node node,int verticleLineNumber){
			this.node=node;
			this.verticleLineNumber=verticleLineNumber;
		}
	}
	
	
	
	static class Node{
		Object data;
		Node left;
		Node right;
		Node(Object data){
			this.data=data;
		}
	}
}
